#include <stdlib.h>
#include <stdio.h>
#include <string.h>

char _PROG_NAME[]= "unhtml" ;
#define PROGRAM_VERSION "1.00"
#define TRUE 1
#define FALSE 0

void help() {

  /* Display the options */

  printf("\nunHTML v%s (c) Adrian.D.Ives\n\n", PROGRAM_VERSION) ;

  printf("Convert the HTML stream on stdin to plain text on stdout.\n\n") ;

}

main(int argc, char **argv) {

  char ch, cch, esc[4096] ;
  int i, inBracket= FALSE, inBody= FALSE, inTitle= FALSE ;

  for ( i= 1 ; i <= argc - 1 ; i++ ) {
    if ( argv[i][0] == '-' ) {
      switch( argv[i][1] ) {
	case  0  :
	case '?' :
	  help() ;
	  return 0 ;
      }
    }
  }

  while ( !feof(stdin) ) {

    ch= fgetc(stdin) ;

    switch ( ch ) {
    case '<' :

      /* Extract the HTML directive */

      i= cch= 0 ;

      while ( !feof(stdin) && i < 4096 && cch != '>' ) {

	cch= fgetc(stdin) ;

	if ( cch == '>' )
	  esc[i]= 0 ;
	else
	  esc[i++]= cch ;

	if ( cch != '>' && i == 3 && strncmp(esc, "!--", 3) == 0 ) {

	  /* Start of a comment block - find its end */

	  int foundEnd= FALSE ;

	  while ( !feof(stdin) && !foundEnd ) {
	    cch= fgetc(stdin) ;
	    if ( cch == '-' && !feof(stdin) )
	      cch= fgetc(stdin) ;
	      if ( cch == '-' && !feof(stdin) )
		cch= fgetc(stdin) ;
		  if ( cch == '>' ) {

		    /* OK, found the "-->" */

		    esc[i]= 0 ;
		    foundEnd= TRUE ;
		  }
	  }
	}
      }

      if ( cch == '>' ) {

	/* Found a directive, but which one? */

	strlwr(esc) ;
	i= strpos(esc, ' ') ;
	if ( i != -1 )
	  esc[i]= 0 ;
	if ( strcmp(esc, "p") == 0 && inBody )
	  fputc('\n', stdout) ;
	else
	if ( strcmp(esc, "body") == 0)
	  inBody= TRUE ;
	else
	if ( strcmp(esc, "/body") == 0)
	  inBody= FALSE ;
	else
	if ( strcmp(esc, "title") == 0)
	  inTitle= TRUE ;
	else
	if ( strcmp(esc, "/title") == 0) {
	  if ( inTitle )
	    fputs("\n\n", stdout) ;
	  inTitle= FALSE ;
	}
      }
      else
	inBracket= TRUE ;
      break ;
    case '>' :
      inBracket= FALSE ;
      break ;
    case '&' :

      if ( !inBracket ) {

	/* Deal with escaped characters */

	i= cch= 0 ;

	while ( !feof(stdin) && i < 64 && cch != ';' ) {
	  cch= fgetc(stdin) ;
	  if ( cch == ';' )
	    esc[i]= 0 ;
	  else
	    esc[i++]= cch ;
	}
	if ( inBody || inTitle ) {
	  strlwr(esc) ;
	  if ( strcmp(esc, "lt") == 0 )
	    fputc('<', stdout) ;
	  else
	  if ( strcmp(esc, "gt") == 0 )
	    fputc('>', stdout) ;
	  else
	  if ( strcmp(esc, "amp") == 0 )
	    fputc('&', stdout) ;
	  else
	  if ( strcmp(esc, "nbsp") == 0 )
	    fputc(' ', stdout) ;
	  else
	  if ( strcmp(esc, "quot") == 0 )
	    fputc('"', stdout) ;
	}
      }
      break ;
    default :
      if ( ( inBody || inTitle ) && ch != '\r' )
	fputc(ch, stdout) ;
    }

  }

  return 0 ;
}
